#!/usr/local/bin/perl

require 5.002;
use Socket;

require "split.cf";

writepid();
sconnect();
register();
parse();
 
sub parse {
        while (<SOCK>)
        {
                chomp;
                if (/:(\S*) PING (\S*) :(\S*)/i) {
                        print SOCK ":$sname PONG $3 :$2\n";
                } elsif (/^PING :(\S*)/i) {
                        print SOCK "PONG $1\n";
                } elsif (/:(\S*) PRIVMSG $snick :(.*)/i) {
			parsemsg($1, $2);
		} elsif (/:(\S*) PRIVMSG $channel :(.*)/i) {
			parsechan($1, $2);
		} elsif (/:(\S*) SERVER (\S*) .*/i) {
			parseserver($1, $2);
		} elsif (/SQUIT (\S*) :(.*)/i) {
			parsesquit($1, $2);
		}
        }
}

sub sconnect {
        $iaddr = inet_aton($server) || die "no host: $server";
        $paddr = sockaddr_in($port, $iaddr);
        $proto = getprotobyname('tcp');
        socket(SOCK, PF_INET, SOCK_STREAM, $proto) || die "socket: $!";
        connect(SOCK, $paddr) || die "connect: $!";

        select SOCK; $| = 1;
        select STDOUT;

	$starttime = time();
}

sub parsechan {
	my $nick = shift;
	$_ = shift;
        if (/^\!split.*/i) {
                my $count=0;
                foreach my $s (keys %servlist)
                {
                        if ($servlist{$s} == 1) {
                                print SOCK ":$snick $chanpn $channel :CURRENT SPLITS:  $s\n";
                                $count++;
                        }
                }
                if ($count == 0) {
                        print SOCK ":$snick $chanpn $channel :NO SPLITS\n";
                }
        }
}

sub parsemsg {
	my $nick = shift;
	$_ = shift;
	if (/^\001PING (.*)\001/i) {
		print SOCK ":$snick PRIVMSG $nick :\001PING $1\001\n";
	}
}

sub parseserver {
	my $to = shift;
	my $new = shift;
	my $now = localtime;
	my $snow = time();
	openlog();
	if ($snow > ($starttime + $interval)) {
		print SOCK ":$snick $chanpn $channel :CONNECT:  $new to $to\n";
		print LOGFILE "$now:  CONNECT:  $new to $to\n";
	}
	closelog();
	$servlist{$new} = 0;
}

sub parsesquit {
	my $split = shift;
	my $reason = shift;
	my $now = localtime;
	openlog();
	print SOCK ":$snick $chanpn $channel :SPLIT:  $split - $reason\n";
	print LOGFILE "$now:  SPLIT:  $split - $reason\n";
	closelog();
	$servlist{$split} = 1;
}

sub register {
	my $stime = time();
	if ($ircdtype eq "Hybrid") {
		print SOCK "PASS $pass TS\n";
		print SOCK "SERVER $sname 1 :$scomment\n";
		print SOCK "SVINFO 3 1 0 :$stime\n";
		print SOCK "NICK $snick 1 1 $smode $suser $shost $sname :$sdesc\n";
		print SOCK ":$snick JOIN $channel\n";
	}
}

sub openlog {
	open(LOGFILE, ">>$logfile");
}

sub writepid {
	open(PIDFILE, ">$pidfile");
	print PIDFILE "$$";
	close(PIDFILE);
}

sub closelog {
	close(LOGFILE);
}

sub loadconf {
	require "greeter.cf";
}

sub sdisconnect {
	close (SOCK) || die "close: $!";
}

